import React from 'react';
import ajax from 'jquery/src/ajax/xhr.js';
import $ from 'jquery/src/ajax';
import { Form,Radio, Icon, Button, Input, Select, Spin, Table, Switch,InputNumber, message, DatePicker, Modal, Upload ,Popconfirm} from 'antd';
import {transactionProject,transactionChannel} from '@/dataDic.js';
import {getOrderState,getOrderChannel,getPaymentState,getOrderType} from '@/tools.js';
const Receivable=React.createClass({
    loadData(record) {
        this.state.data = [];
        this.setState({
            loading: true
        });
        $.ajax({
            method: "get",
            dataType: "json",
            crossDomain: false,
            url: globalConfig.context + '/api/admin/order/getOrderCommodity',
            data: {
            	orderNo:record?record.orderNo:this.props.data.orderNo
            },
            success: function (data) {
                let theArr = [];
                if (!data.data) {
                    if (data.error && data.error.length) {
                        message.warning(data.error[0].message);
                    };
                } else {
                    for (let i = 0; i < data.data.length; i++) {
                        let thisdata = data.data[i];
                        theArr.push({
                             key: i,
                             id:thisdata.id,
                             orderNo:thisdata.orderNo,
                             commodityName:thisdata.commodityName,
                             commodityType:thisdata.commodityType,
                             commodityMode:thisdata.commodityMode,
                             commodityQuantity:thisdata.commodityQuantity,
                             commodityPrice:thisdata.commodityPrice,
                             discountPrice:thisdata.discountPrice,
                             commodityFirstPayment:thisdata.commodityFirstPayment,
                             createTimes:thisdata.createTimes,
                             discountFirstPayment:thisdata.discountFirstPayment,
                             remarks:thisdata.remarks,
                             commodityId:thisdata.commodityId,
                        });
                    };
                   }
                this.setState({
                    dataSource: theArr,
                    pagination: false,
                });
            }.bind(this),
        }).always(function () {
            this.setState({
                loading: false
            });
        }.bind(this));
    },
    getInitialState() {
        return {
        	datauser:{},
            loading: false,
            visible:false,
            showDesc:false,
        };
    },
    //保存
    handleSubmit(e){
        e.preventDefault();
        if(!this.state.settlementAmount){
                message.warning('请填写金额');
                return false;
        }
        if(!this.state.transactionProject){
            message.warning('请选择流水科目');
            return false;
        }
        if(!this.state.transactionChannel){
            message.warning('请选择交易渠道');
            return false;
        }
        this.setState({
            loading: true
        });
        $.ajax({
            method: "post",
            dataType: "json",
            async:true,
            url:  globalConfig.context + '/api/user/demand/apply',
            data: {
                id: this.props.data.id,
                settlementAmount: this.state.settlementAmount,
                transactionProject: this.state.transactionProject,
                transactionChannel: this.state.transactionChannel,
                remarks:this.state.remarks
            }
        }).done(function (data) {
            this.setState({
                loading: false
            });
            if (!data.error.length) {
                message.success('操作成功！');
                this.onShow();
            } else {
                message.warning(data.error[0].message);
            }
        }.bind(this));
    },
    onCancel(){
    	this.setState({
    		visible:false
        })
        this.props.closeDesc(false,false);
    },
    onShow() {
		this.setState({
			visible: false,
		});
		this.props.closeDesc(false, true);
	},
    componentWillMount() {
        this.loadData();
        this.setState({
            transactionProject:undefined,
            settlementAmount:undefined,
            transactionChannel:undefined,
            remarks:''
        })
    },
    componentWillReceiveProps(nextProps) {
        this.loadData(nextProps.data);
        this.state.visible=nextProps.showDesc;
        this.setState({
            transactionProject:undefined,
            settlementAmount:undefined,
            transactionChannel:undefined,
            remarks:''
        })
    },
    render() {
        const theData = this.state.data || {};
        const { getFieldDecorator,getFieldsValue } = this.props.form;
        const FormItem = Form.Item;
        const formItemLayout = {
            labelCol: { span: 10 },
            wrapperCol: { span: 12 },
		};
        return (
            <div className="user-content" >
	            <Modal maskClosable={false} visible={this.state.visible}
                        onOk={this.onShow} onCancel={this.onCancel}
                        width='800px'
                        title='添加收款记录'                     
                        footer=''
                        className="admin-desc-content">
			            <Form layout="horizontal" onSubmit={this.handleSubmit} >
			                <Spin spinning={this.state.loading}>
                                <div className="clearfix">
                                    <FormItem className="half-item" {...formItemLayout} label="平台流水编号">
                                        <span>{theData.name}</span>
                                    </FormItem>
                                    <FormItem className="half-item" {...formItemLayout} label="平台流水时间">
							            <span>{theData.releaseDate?(new Date(theData.releaseDate)).toLocaleString():''}</span>
                                    </FormItem>
                                    <FormItem className="half-item" {...formItemLayout} label={<span><strong style={{color:'#f00'}}>*</strong>金额</span>}>
                                        <InputNumber min={0} max={9999} placeholder="金额" 
                                            value={this.state.settlementAmount}
                                            onChange={(e)=>{this.setState({settlementAmount:e})}}
                                        />
                                        <span style={{ marginLeft: '5px' }}>万元</span>
                                    </FormItem>
                                    <FormItem className="half-item" {...formItemLayout} label={<span><strong style={{color:'#f00'}}>*</strong>流水科目</span>}>
                                        <Select placeholder="流水科目" 
                                            value={this.state.transactionProject}
                                            onChange={(e)=>{this.setState({transactionProject:e})}}
                                            >
                                            { 
                                                transactionProject.map(function (item) {
                                                    return	<Select.Option value={item.value} key={item.key}>{item.key}</Select.Option>
                                                })
                                            }
                                        </Select>
                                    </FormItem>
                                    <FormItem className="half-item" {...formItemLayout} label="付款方">
                                        <span>{theData.name}</span>
                                    </FormItem>
                                    <FormItem className="half-item" {...formItemLayout} label="收款方">
                                        <span>{theData.name}</span>
                                    </FormItem>
                                    <FormItem className="half-item" {...formItemLayout} label={<span><strong style={{color:'#f00'}}>*</strong>交易渠道</span>}>
                                        <Select placeholder="交易渠道" 
                                            value={this.state.transactionChannel}
                                            onChange={(e)=>{this.setState({transactionChannel:e})}}
                                        >
                                            { 
                                                transactionChannel.map(function (item) {
                                                    return	<Select.Option value={item.value} key={item.key}>{item.key}</Select.Option>
                                                })
                                            }
                                        </Select>
                                    </FormItem>
                                    <FormItem className="half-item" {...formItemLayout} label="订单编号">
                                        <span>{theData.orderNo}</span>
                                    </FormItem>
                                    <FormItem className="half-item" {...formItemLayout} label="财务流水编号">
                                        <span>{theData.orderNo}</span>
                                    </FormItem>
                                    <FormItem labelCol={{ span: 5 }} wrapperCol={{ span: 16 }} label="备注">
                                        <Input
                                            type="textarea"
                                            rows={4}
                                            placeholder="请输入备注"
                                            value={this.state.remarks}
                                            onChange={(e) => {
                                                this.setState({ remarks: e.target.value });
                                            }}
                                        />
                                    </FormItem>
                                    <FormItem wrapperCol={{ span: 12, offset:5 }}>  
                                        <Button type="primary" htmlType="submit"  style={{marginRight:20}}>确认</Button>
                                        <Button type="default" onClick={()=>{this.onCancel()}}>取消</Button>
                                    </FormItem>  
                                </div>
			                </Spin>
			            </Form>
			    </Modal>
            </div>
        );
    }
});

export default Form.create()(Receivable);